TestCase subclass: #TestRangos
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'RangosExcel-Test'!

!TestRangos methodsFor: 'tests' stamp: 'DS 5/7/2020 21:31'!
test02DadoUnRangoVerticalEntreA1yA10todasLasDireccionesDebenExistirDentroDeEste
	| rango |
	rango := RangoVertical2 desde: (Direccion columna: $A fila: 1) hasta: (Direccion columna: $A fila: 10).
	
	"P 03 - Pendiente"
	self assert: (rango contiene: (Direccion columna: $A fila: 1)).	
	self assert: (rango contiene: (Direccion columna: $A fila: 2)).	
	self assert: (rango contiene: (Direccion columna: $A fila: 10)).	
	"Fin 'P 03"
	
	self deny: (rango contiene: (Direccion columna: $a fila: 11)).! !

!TestRangos methodsFor: 'tests' stamp: 'DS 5/7/2020 21:31'!
test03DadoUnRangoVerticalEntreA1yA10ContinueandoEnA22yA25todasLasDireccionesDebenExistirDentroDeEste
	
	| a1 a10 a22 a25 rango01 rango02 rangoPartido |
	a1 := Direccion columna: $a fila: 1.
	a10 := Direccion columna: $a fila: 10.
	
	a22 := Direccion columna: $a fila: 22.
	a25 := Direccion columna: $a fila: 25.
	 
	rango01 := RangoVertical2 desde: a1 hasta: a10.
	rango02 := RangoVertical2 desde: a22 hasta: a25.

	rangoPartido := RangoPartido componer: { rango01. rango02. }.
	
	"P04 - Pendiente"
	" - Herencia "
	" - Delegacion"
	
	self assert: (rangoPartido contiene: a1).
	self assert: (rangoPartido contiene: (Direccion columna: $a fila: 2)).
	self assert: (rangoPartido contiene: a22).
	self assert: (rangoPartido contiene: (Direccion columna: $a fila: 23)).
	self assert: (rangoPartido contiene: a25).
	"Final 'P 04"! !

!TestRangos methodsFor: 'tests' stamp: 'DS 5/7/2020 21:31'!
test01DadoUnRangoHorizontalEntreA1yC1todasLasDireccionesDebenExistirDentroDeEste
	| rango |
	rango := RangoHorizontal desde: (Direccion columna: $A fila: 1) hasta: (Direccion columna: $C fila: 1).
	
	self assert: (rango contiene: (Direccion columna: $A fila: 1)).	
	self assert: (rango contiene: (Direccion columna: $a fila: 1)).	

	"P 01 - Pendiente"
	"Acerca de ocultamiento de la informacion y encapsulamiento"
	" - Detalles de implementacion permean"
	" - Estado consistente del objeto"
	"self assert: (rango continiene: (Direccion columna: $a fila: 1)).
	"
	"Fin 'P 01"
	
	self deny: (rango contiene: (Direccion columna: $Z fila: 1)).
	
	"P 02 - Pendiente"
	self assert: (rango contiene: (Direccion columna: $B fila: 1)).
	self assert: (rango contiene: (Direccion columna: $c fila: 1)).
	"Fin 'P 02"
	
	! !
