Object subclass: #Direccion
	instanceVariableNames: 'columna fila'
	classVariableNames: ''
	package: 'RangosExcel'!

!Direccion methodsFor: 'accessing - private' stamp: 'DS 5/7/2020 09:54'!
mismaColumnaQue: otraDireccon 
	| a b |
	a := columna asUppercase.
	b := otraDireccon columna asUppercase.
	^a = b.! !

!Direccion methodsFor: 'accessing - private' stamp: 'DS 4/30/2020 21:50'!
mismaFilaQue: otraDireccion 
	^fila == otraDireccion fila.! !

!Direccion methodsFor: 'accessing - private' stamp: 'DS 4/30/2020 21:50'!
columna
	^ columna! !

!Direccion methodsFor: 'accessing - private' stamp: 'DS 4/30/2020 21:48'!
columna: unaColumnaComoStr fila: unaFila 
	columna := unaColumnaComoStr.
	fila := unaFila.! !

!Direccion methodsFor: 'accessing - private' stamp: 'DS 4/30/2020 21:51'!
fila
	^ fila! !

!Direccion methodsFor: 'accessing - private' stamp: 'DS 5/7/2020 09:38'!
asString 
	^columna asString, fila asString.! !


!Direccion methodsFor: 'as yet unclassified' stamp: 'DS 4/30/2020 21:49'!
esIgualA: otraDireccion
	^(self mismaColumnaQue: otraDireccion) and: (self mismaFilaQue: otraDireccion ).! !

!Direccion methodsFor: 'as yet unclassified' stamp: 'DS 5/7/2020 20:12'!
sigDireccionVertical
	^Direccion columna: columna fila: (fila +1). ! !

!Direccion methodsFor: 'as yet unclassified' stamp: 'DS 5/7/2020 19:50'!
sigDireccionHorizontal
	|result|
	result := columna asInteger.
	^Direccion columna: ((result + 1) asCharacter) fila: fila.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Direccion class
	instanceVariableNames: ''!

!Direccion class methodsFor: 'as yet unclassified' stamp: 'DS 4/30/2020 21:47'!
columna: unaColumnaComoStr fila: unaFila 
	|result|
	
	result := self new.
	result columna: unaColumnaComoStr fila: unaFila.
	
	^result.
	! !


Object subclass: #Rango
	instanceVariableNames: 'desde hasta'
	classVariableNames: ''
	package: 'RangosExcel'!

!Rango methodsFor: 'as yet unclassified' stamp: 'DS 5/7/2020 20:31'!
desdeHastaDirCeldas
	self subclassResponsibility.! !

!Rango methodsFor: 'as yet unclassified' stamp: 'DS 5/7/2020 21:31'!
contiene: unaDireccion
	| dirCeldas result|
	dirCeldas := self desdeHastaDirCeldas.
	result := dirCeldas
		detect: [ :d | d esIgualA: unaDireccion ]
		ifFound: [ true ]
		ifNone: [ false ].
	^ result! !


!Rango methodsFor: 'accessing - private' stamp: 'DS 5/7/2020 20:34'!
desde: unaDireccion  hasta: otraDireccion
	desde := unaDireccion.
	hasta := otraDireccion.! !


Rango subclass: #RangoHorizontal
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'RangosExcel'!


!RangoHorizontal methodsFor: 'as yet unclassified' stamp: 'DS 5/7/2020 19:49'!
desdeHastaDirCeldas
	|result|
	
	result := { desde "A1". hasta "C1". } asOrderedCollection.
	
	"P 02 - Pendiente"
	"result add: (Direccion columna: (self sigCol) fila: (desde fila)).
	""Fin 'P02"
	
	result add: desde sigDireccionHorizontal.
	
	^result.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RangoHorizontal class
	instanceVariableNames: ''!

!RangoHorizontal class methodsFor: 'as yet unclassified' stamp: 'DS 4/30/2020 21:42'!
desde: unDireccion hasta: otraDireccion 
	|result|
	result := self new.
	result desde: unDireccion hasta: otraDireccion .
	^result.! !


Object subclass: #RangoPartido
	instanceVariableNames: 'rangos'
	classVariableNames: ''
	package: 'RangosExcel'!

!RangoPartido methodsFor: 'accessing - private' stamp: 'DS 5/7/2020 10:26'!
rangos: unosRangos
	rangos := unosRangos.! !


!RangoPartido methodsFor: 'as yet unclassified' stamp: 'DS 5/7/2020 21:31'!
contiene: unaDireccion  
	|result|
	
	result := rangos detect: [ :r |
		r contiene: unaDireccion
	] ifFound: [ 
		true
	] ifNone: [ 
		false
	].
	^result ! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RangoPartido class
	instanceVariableNames: ''!

!RangoPartido class methodsFor: 'as yet unclassified' stamp: 'DS 5/7/2020 10:26'!
componer: unosRangos 
	|result|
	result := self new.
	result rangos: unosRangos.
	^result.! !


Rango subclass: #RangoVertical2
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'RangosExcel'!

!RangoVertical2 methodsFor: 'as yet unclassified' stamp: 'DS 5/7/2020 21:10'!
desdeHastaDirCeldas
	|result|
	
	result := { desde "A1". hasta "C1". } asOrderedCollection.
	
	"P 02 - Pendiente"
	"result add: (Direccion columna: (self sigCol) fila: (desde fila)).
	""Fin 'P02"
	
	result add: desde sigDireccionVertical .
	
	^result.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RangoVertical2 class
	instanceVariableNames: ''!

!RangoVertical2 class methodsFor: 'accessing - private' stamp: 'DS 5/7/2020 21:11'!
desde: unDireccion hasta: otraDireccion 
	|result|
	result := self new.
	result desde: unDireccion hasta: otraDireccion .
	^result.! !
